% limb manual
% autoopt.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

autoopt.h - automatic handling/parsing of options

# SYNOPSIS

    #include <limb/autoopt.h>

# DESCRIPTION

This header defines functions to handle options automatically.

## Macros

The following macros are defined :

: *AUTOOPT_QUIET*, *AUTOOPT_VERBOSE*, *AUTOOPT_LOG*, *AUTOOPT_DEBUG*
:: Macros to define options that can be handled via functions below.

## Functions

The following functions are defined :

: [autoopt_quiet](3)
:: To handle option to bump output level down.

: [autoopt_verbose](3)
:: To handle option to raise output level up.

: [autoopt_log](3)
:: To handle option to set up a log output.

: [autoopt_debug](3)
:: To handle option to raise output to debug level, or set up a debug output.

: [autoopt_parse_buffer_dest](3)
:: To parse the destination for an output buffer.
