% limb manual
% blake3.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

blake3.h - BLAKE3 message digest

# SYNOPSIS

    #include <limb/blake3.h>

# DESCRIPTION

This header defines the required function to compute the BLAKE3 hash of a given
block of data.

## Types

The following types are defined :

: *blake3_ctx*
:: An opaque structure to be given to the functions below.

## Functions

The following functions are defined :

: [blake3_init](3)
:: To initialize a blake3 context.

: [blake3_update](3)
:: To feed data into the blake3 context.

: [blake3_final](3)
:: To obtain the hash from a blake3 context.
