% limb manual
% ccpl.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

ccpl.h - ChaCha20-Poly1305 AEAD encryption

# SYNOPSIS

    #include <limb/ccpl.h>

# DESCRIPTION

This header defines the required function to encrypt/decrypt messages using the
ChaCha20-Poly1305 AEAD algorithm.

## Types

The following types are defined :

: *ccpl_ctx*
:: An opaque structure to be given to the functions below.

## Functions

The following functions/macros are defined :

: [ccpl_init](3)
:: To initialize a ccpl context.

: [ccpl_aad](3)
:: To feed additional data into a ccpl context.

: [ccpl_crypt](3)
:: To crypt data using a ccpl context.

: [ccpl_encrypt](3)
:: To encrypt data using a ccpl context;

: [ccpl_decrypt](3)
:: To decrypt data using a ccpl context.

: [ccpl_final](3)
:: To obtain the MAC from a ccpl context.
