% limb manual
% chacha20.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

chacha20.h - ChaCha20 encryption

# SYNOPSIS

    #include <limb/chacha20.h>

# DESCRIPTION

This header defines the required function to encrypt/decrypt messages using the
ChaCha20 cipher.

## Types

The following types are defined :

: *chacha20_ctx*
:: An opaque structure to be given to the functions below.

## Functions

The following functions are defined :

: [chacha20_init](3)
:: To initialize a chacha20 context.

: [chacha20_crypt](3)
:: To encrypt/decrypt a message.

: [chacha20_clear](3)
:: To clear a chacha20 context.

: [chacha20](3)
:: Convenience function to encrypt/decrypt a message at once.
