% limb manual
% direntry.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

direntry.h - directory operations


# SYNOPSIS

    #include <limb/direntry.h>


# DESCRIPTION

The header defines the needed functions to deal with directory streams.

<inc skalibs.md>

## Types

The following types are defined :

: *direntry*
:: A *struct dirent*

## Macros

The following macros are defined :

: *ISDOTDOT(`de`)*
:: Returns whether the pointed *direntry* is that of the `.` or `..` file

## Functions

The following functions are defined :

: [opendirat](3)
:: Open a directory stream, with relative path to a given file descriptor.

: [dir_close](3)
:: Close a directory stream.

: [dir_fd](3)
:: Similar to [dirfd](3)

: [sa_scandirat](3)
:: Scan a directory to fill a *stralloc*.

: [sa_scandir](3)
:: Similar to [sa_scandirat](3) except for relative path.
