% limb manual
% exitcode.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

exitcode.h - standardized exit codes


# SYNOPSIS

    #include <limb/exitcode.h>


# DESCRIPTION

The header defines some standardized exit codes aimed to provide consistency
amongst applications. They are based upon/taken from BSD's own `sysexits.h`

## Constants

The following constants are defined :

: *EX_USAGE*
:: Incorrect usage.

: *EX_DATA_ERR*
:: Invalid input/user data.

: *EX_NOINPUT*
:: Input/user file missing or not readable.

: *EX_NOUSER*
:: Specified user does not exist.

: *EX_NOHOST*
:: Specified host does not exist.

: *EX_UNAVAILABLE*
:: Service unavailable, or support file/program does not exist.
:: May also be a catch-all for "something didn't work, don't know what"

: *EX_SOFTWARE*
:: Internal error.

: *EX_OSERR*
:: OS error, e.g. cannot fork, cannot create pipe, etc.

: *EX_OSFILE*
:: System file (e.g. `/etc/passwd`) does not exist, cannot be open, has invalid
:: syntax, etc.

: *EX_CANTCREAT*
:: (User-specified) output file cannot be created.

: *EX_IOERR*
:: I/O error.

: *EX_TEMPFAIL*
:: Temporary error, try again (e.g. no memory).

: *EX_PROTOCOL*
:: Invalid value during protocol exchange.

: *EX_NOPERM*
:: Permission denied.
:: ! INFO: Recommendation
:: ! Make sure to use *EX_NOINPUT* or *EX_CANTCREAT* instead if applicable.

: *EX_CONFIG*
:: Configuration error.
