% limb manual
% genalloc_remove(3)
% limb 0.1.0
% 2023-07-24

# NAME

genalloc_remove - remove data from a genalloc

# SYNOPSIS

    #include <limb/genalloc.h>

```pre hl
int genalloc_remove(<em>type</em>, genalloc *<em>ga</em>, int <em>offset</em>, int <em>num</em>)
```

# DESCRIPTION

The `genalloc_remove`() macro removes `num` elements from the genalloc `ga`
starting with element `offset`th.

The member `len` will be adjusted and data afterwards moved as needed, but no
re-allocation occurs.

# RETURN VALUE

The `genalloc_remove`() function returns 1 on success. Otherwise it returns 0
and sets `errno` to indicate the error.

# ERRORS

The `genalloc_remove`() function may fail for the errors described for
[stralloc_remove](3).

# SEE ALSO

[genalloc_shrink](3)
