% limb manual
% hlookup.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

hlookup.h - Fast lookup hashes


# SYNOPSIS

    #include <limb/hlookup.h>

# DESCRIPTION

The header defines the needed functions to compute fast lookup hashes. Those
hashes are aimed to be used in hash table lookups, *not* for cryptographic
purposes.

## Functions

The following functions are defined :

: [hlookup](3)
:: Compute 32bit hashes of given block of data

: [hlookup32](3)
:: Return the 32bit hash of given block of data

: [hlookup64](3)
:: Return the 64bit hash of given block of data

# SEE ALSO

[hmap.h](0), [hasher.h](0)
