% limb manual
% hmap.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

hmap.h - hash table management


# SYNOPSIS

    #include <limb/hmap.h>

# DESCRIPTION

The header defines the needed functions to work with hash tables.

## Constants

The following constants are defined :

: *HMAP_ZERO*
:: Value that can be used to initialize a stack-allocated hash table.

## Structures

The following structures are defined :

: *struct hmap*
:: The structure that describes the hash table on which the functions operate,
:: which should be considered opaque.

## Functions

The following functions are defined :

: [hmap_init](3)
:: Initializes an hash table, setting the size of its elements.

: [hmap_next](3)
:: To iterate over all elements in an hash table.

: [hmap_set](3)
:: Sets (or adds) the data associated with the given key.

: [hmap_get](3)
:: Returns a pointer to the data associated with the given key.

: [hmap_free](3)
:: Frees all memory allocated by the table.
