% limb manual
% memxor(3)
% limb 0.1.0
% 2023-07-24

# NAME

memxor, memxor3 - XOR memory areas

# SYNOPSIS

    #include <limb/memxor.h>

```pre hl
void memxor(void *<em>dst</em>, const void *<em>src</em>, size_t <em>len</em>)
void memxor3(void *<em>dst</em>, const void *<em>src1</em>, const void *<em>src2</em>, size_t <em>len</em>)
```

# DESCRIPTION

The `memxor`() function will XOR the content of memory pointed to by `src` and
`dst` over `len` bytes, storing the result over the memory area pointed to by
`dst`.

The `memxor3`() is similar, but the results of XOR-ing areas pointed to by
`src1` and `src2` will be stored in memory pointed to by `dst`.
