% limb manual
% nextsplit.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

nextplit.h - finding the next split for variable-length chunks in a data stream


# SYNOPSIS

    #include <limb/nextsplit.h>

# DESCRIPTION

This header defines functions to determine the next split for variable-length
chunks in a data stream.

## Functions

The following functions are defined :

: [nextsplit_ae](3)
:: Use Asymmetric Extremum Content Defined Chunking to determine the next split
:: in a given data block

: [nextsplit_buz](3)
:: Use buzhash rolling hash to determine the next split in a given data block

: [nextsplit_rabin](3)
:: Use rolling hash based on Rabin fingerprint to determine next split in a
:: given data block
