% limb manual
% obuffer_put(3)
% limb 0.1.0
% 2023-07-24

# NAME

obuffer\_put - write data to an output buffer

# SYNOPSIS

    #include <limb/obuffer.h>

```pre hl
void obuffer_put(obuffer *<em>obuf</em>, u8 <em>level</em>, const char *<em>data</em>, size_t <em>dlen</em>)
```

# DESCRIPTION

The `obuffer_put`() function will write the data pointed to by `data`, of length
`dlen`, into the output buffer `obuf` and all attached to it, if their level is
at least `level`.

If an output buffer has a level lower than `level` then nothing is written to
it.

# SEE ALSO

[obuffer_attach](3), [obuffer_setlevel](3)
