% limb manual
% obuffer_putmsg(3)
% limb 0.1.0
% 2023-07-24

# NAME

obuffer\_putmsg - write message, given as an array of strings, to an output
buffer

# SYNOPSIS

    #include <limb/obuffer.h>

```pre hl
void obuffer_putmsg(obuffer *<em>obuf</em>, u8 <em>level</em>, const char * const *<em>as</em>, unsigned int <em>n</em>)
```

# DESCRIPTION

The `obuffer_putmsg`() function will write the message, given as array of
strings `as` of `n` elements, into the output buffer `obuf` and all attached to
it, if their level is at least `level`.

If an output buffer has a level lower than `level` then nothing is written to
it.

# SEE ALSO

[obuffer_attach](3), [obuffer_setlevel](3)
