% limb manual
% warn(3)
% limb 0.1.0
% 2023-07-24

# NAME

warn, warnu, warnsys, warnusys - write a warning to standard error

# SYNOPSIS

    #include <limb/output.h>
    extern const char *PROG;

```pre hl
void warn(..)
void warnu(...)
void warnsys(...)
void warnusys(...)
```

# DESCRIPTION

All of those are implemented as macros and will write the specified strings as
warning to *stderr* output buffers (with level *OLVL_NORMAL* or more), with a
new line added at the end.

<inc obuffers.md>

All warnings will be prefixed by the program's name (i.e. value of `PROG`), the
word "warning " in between colon and a space.

`warnu`() will add "unable to " after the prefix and before the given strings.

The `warnsys`() and `warnusys`() macros are similar, only the specified strings
will be followed by a colon, a space and the error description provided by
[strerror](3) according to `errno`.

! HINT:
! Some special features are supported, to e.g. easily include a number or
! perform escaping of some strings. Refer to [out](3), or directly
! [buffer_putmsg](3), for more.

# SEE ALSO

[out](3), [buffer_putmsg](3)
