% limb manual
% poly1305.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

poly1305.h - Poly1305 authentication

# SYNOPSIS

    #include <limb/poly1305.h>

# DESCRIPTION

This header defines the required function to compute Poly1305-based MAC of
messages.

## Types

The following types are defined :

: *poly1305_ctx*
:: An opaque structure to be given to the functions below.

## Functions

The following functions are defined :

: [poly1305_init](3)
:: To initialize a poly1305 context.

: [poly1305_update](3)
:: To feed data into a poly1305 context.

: [poly1305_final](3)
:: To obtain the HMAC from a poly1305 context.
