% limb manual
% sha3.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

sha3.h - SHA3 message digest

# SYNOPSIS

    #include <limb/sha3.h>

# DESCRIPTION

This header defines the required function to compute the SHA3 hash of a given
block of data.

## Types

The following types are defined :

: *sha3_ctx*
:: An opaque structure to be given to the functions below.

## Functions

The following functions are defined :

: [sha3_224_init](3)
:: To initialize a sha3-224 context.

: [sha3_256_init](3)
:: To initialize a sha3-256 context.

: [sha3_384_init](3)
:: To initialize a sha3-384 context.

: [sha3_512_init](3)
:: To initialize a sha3-512 context.

: [sha3_update](3)
:: To feed data into the sha3 context.

: [sha3_final](3)
:: To obtain the hash from a sha3 context.
