% limb manual
% shldata.h(0)
% limb 0.1.0
% 2023-07-24

# NAME

shldata.h - encrypt/decrypt data using the shielded data protocol

# SYNOPSIS

    #include <limb/shldata.h>

# DESCRIPTION

The header defines functions used to encrypt/decrypt data using the "shielded
data" protocol. Refer to [shldata](5) for more.

## Types

The following types are defined :

: *shldata_ctx*
:: An opaque structure to be given to the function below.

## Functions

The following functions/macros are defined :

: [shldata_initw](3)
:: To initialize encryption of data through the shielded data protocol.

: [shldata_encrypt](3)
:: To encrypt data through the shielded data protocol.

: [shldata_predata](3)
:: Part of the shielded data encryption protocol.

: [shldata_finalw](3)
:: To finalize the encryption of data through the shielded data protocol.

: [shldata_initr](3)
:: To initialize decryption through the shielded data protocol.

: [shldata_datasize](3)
:: Returns the length of encrypted data to be decrypted through the shielded data
:: protocol.

: [shldata_decrypt](3)
:: To decrypt data through the shielded data protocol.

: [shldata_finalr](3)
:: To finalize the decryption of data through the shielded data protocol.
