% limb manual
% siov_off(3)
% limb 0.1.0
% 2023-07-24

# NAME

siov_off - return the byte at the given offset in an array of vectors

# SYNOPSIS

    #include <limb/siovec.h>

```pre hl
int siov_off(const struct iovec *<em>v</em>, unsigned int <em>n</em>, size_t <em>off</em>)
```

# DESCRIPTION

The `siov_off`() function returns the byte at offset `offset` from the data
scattered across given array `v` of `n` vectors.

# RETURN VALUE

The `siov_off`() function returns the `offset + 1`th byte of data scattered the
specified array of vectors, or -1 and set `errno` to indicate the error.

# ERRORS

The function may fail if:

: *EINVAL*
:: The value `offset` is invalid

# SEE ALSO

[siov_seek](3), [siov_gather](3)
