/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* Based on RHash: http://rhash.sourceforge.net/
 * Copyright (c) 2005 Aleksey Kravchenko */
/* SPDX-License-Identifier: 0BSD */
#ifndef LIMB_SHA3_SHA3_H
#define LIMB_SHA3_SHA3_H

#include <limb/gccattributes.h>
#include <limb/sha3.h>
#include "sha3/byte_order.h"

#define SHA3_FINALIZED 0x80000000

void sha3_init(unsigned bits, sha3_ctx *ctx) gccattr_hidden;
void rhash_sha3_process_block(uint64_t hash[25], const uint64_t *block, size_t block_size) gccattr_hidden;

#endif /* LIMB_SHA3_SHA3_H */
