/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_AUTOOPT_H
#define LIMB_AUTOOPT_H

#include <limb/parseopt.h>

/* bump output level down to silent */
#define AUTOOPT_QUIET(s,l,f,i)      OPTION_ARG_NONE(s, l, f, i)
/* raise output level up to maximum */
#define AUTOOPT_VERBOSE(s,l,f,i)    OPTION_ARG_NONE(s, l, f, i)
/* set up log output to specified fd/file */
#define AUTOOPT_LOG(s,l,f,i)        OPTION_ARG_REQ( s, l, f, i)
/* set up debut output to specified fd/file */
#define AUTOOPT_DEBUG(s,l,f,i)      OPTION_ARG_OPT( s, l, f, i)

extern int autoopt_quiet(const struct option *option, const char *arg);
extern int autoopt_verbose(const struct option *option, const char *arg);
extern int autoopt_log(const struct option *option, const char *arg);
extern int autoopt_debug(const struct option *option, const char *arg);

extern int autoopt_parse_buffer_dest(const struct option *option, const char *arg, u8 *lvl);

#endif /* LIMB_AUTOOPT_H */
