/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_CCPL_H
#define LIMB_CCPL_H

#include <limb/chacha20.h>
#include <limb/int.h>
#include <limb/poly1305.h>

struct ccpl_ctx {
    struct chacha20_ctx cc;
    struct poly1305_ctx pl;
    u64 alen;
    u64 dlen;
    u8 w;
};

typedef struct ccpl_ctx ccpl_ctx;

extern void ccpl_init(void *key, void *nonce, void *ctx);
extern int ccpl_aad(const void *data, size_t dlen, void *ctx);
extern void ccpl_crypt(void *dst, const void *data, size_t dlen, int encrypt, void *ctx);
#define ccpl_encrypt(dst,data,dlen,ctx)     ccpl_crypt(dst, data, dlen, 1, ctx)
#define ccpl_decrypt(dst,data,dlen,ctx)     ccpl_crypt(dst, data, dlen, 0, ctx)
extern void ccpl_final(void *dst, void *ctx);

#endif /* LIMB_CCPL_H */
