/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_CDBMAKE_H
#define LIMB_CDBMAKE_H

#include <skalibs/cdbmake.h>
#include <skalibs/genalloc.h>
#include <limb/int.h>
#include <limb/stralloc.h>

#define cdbmaker_start      cdbmake_start
#define cdbmaker_add        cdbmake_add
#define cdbmaker_finish     cdbmake_finish

struct cdbmaker_sa
{
    stralloc sa;
    genalloc hplist;
};
typedef struct cdbmaker_sa cdbmaker_sa;

#define CDBMAKER_SA_ZERO        { STRALLOC_ZERO, GENALLOC_ZERO }

extern void cdbmaker_sa_init(cdbmaker_sa *m);
extern int cdbmaker_sa_start(cdbmaker_sa *m);
extern int cdbmaker_sa_add(cdbmaker_sa *m, const char *key, u32 klen, const char *data, u32 dlen);
extern int cdbmaker_sa_finish(cdbmaker_sa *m);
#define cdbmaker_sa_data(ctx)   ((const char *) (ctx)->sa.s)
#define cdbmaker_sa_dlen(ctx)   (ctx)->sa.len
extern void cdbmaker_sa_free(cdbmaker_sa *m);

#endif /* LIMB_CDBMAKE_H */
