/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_CHACHA20_H
#define LIMB_CHACHA20_H

#include <stddef.h> /* size_t */
#include <limb/int.h>

#define CHACHA_U32_BLOCK_SIZE      16
#define CHACHA_BLOCK_SIZE          (sizeof(u32) * CHACHA_U32_BLOCK_SIZE)

struct chacha20_ctx
{
    u32 in[CHACHA_U32_BLOCK_SIZE];
    u8 part;
};

typedef struct chacha20_ctx chacha20_ctx;

extern void chacha20_init(const void *key, const void *nonce, void *ctx);
extern void chacha20_crypt(void *dst, const void *msg, size_t mlen, void *ctx);

extern void chacha20_clear(void *ctx);
extern void chacha20(void *dst, const void *key, const void *nonce, const void *msg, size_t mlen);

#endif /* LIMB_CHACHA20_H */
