/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_COMMAND_H
#define LIMB_COMMAND_H

typedef int (*main_fn) (int argc, const char *argv[], const char *env[],
                        const char usage[], void *ctx);

#define COMMAND(n, d, u, h) \
    int n ## _main (int argc, const char *argv[], const char *env[], \
                    const char usage[], void *ctx); \
    struct command command_ ## n = { #n, d, u, h, n ## _main }

struct command {
    const char *name;
    const char *desc;
    const char *usage;
    const char *help;
    main_fn main;
};

extern struct command *commands[];
extern unsigned n_commands;

#define N_COMMANDS  unsigned n_commands = sizeof(commands) / sizeof(*commands) - 1

extern void dienocommand(int exit, const char *usage, const char *help);
extern struct command *getcommandordie(int exit, const char *usage, const char *arg);

#endif /* LIMB_COMMAND_H */
