/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_COPA_H
#define LIMB_COPA_H

#include <sys/types.h> /* size_t */

/* opaque structure */
struct copa {
    const char *data;
    size_t dlen;
    size_t noff;
    size_t nlen;
    size_t voff;
    size_t vlen;
};

extern void copa_init(const char *data, size_t dlen, struct copa *ctx);
extern int copa_next(struct copa *ctx);

#define copa_is_section(ctx)    (copa_name(ctx)[(ctx)->nlen] == ']')
#define copa_name(ctx)          ((ctx)->data + (ctx)->noff)
#define copa_nlen(ctx)          (ctx)->nlen
#define copa_value(ctx)         ((ctx)->data + (ctx)->voff)
#define copa_vlen(ctx)          (ctx)->vlen

#endif /* LIMB_COPA_H */
