/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_DIRENTRY_H
#define LIMB_DIRENTRY_H

#include <skalibs/direntry.h>
#include <limb/stralloc.h>

typedef ssize_t (*sa_scande) (stralloc *sa, direntry *de, int bfd, void *ctx);

#define ISDOTDOT(de)    ((de)->d_name[0] == '.' && (!(de)->d_name[1] || ((de)->d_name[1] == '.' && !(de)->d_name[2])))

extern DIR *opendirat(int bfd, const char *name);

extern int sa_scandirat(stralloc *sa, int bfd, const char *name, sa_scande fn, void *ctx);
#define sa_scandir(sa,name,fn,ctx)  sa_scandirat(sa, AT_FDCWD, name, fn, ctx)

#endif /* LIMB_DIRENTRY_H */
