/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_GENALLOC_H
#define LIMB_GENALLOC_H

#include <stdlib.h> /* qsort*() */
#include <skalibs/genalloc.h>

#define genalloc_remove(type, ga, offset, n)    stralloc_remove((ga), (offset) * sizeof(type), (n) * sizeof(type))

#define genalloc_qsort_full(type, ga, from, len, cmp)           qsort((void *) (&genalloc_s(type, (ga))[from]), len, sizeof(type), cmp)
#define genalloc_qsort_r_full(type, ga, from, len, cmp, ctx)    qsort_r((void *) (&genalloc_s(type, (ga))[from]), len, sizeof(type), cmp, ctx)

#define genalloc_qsort(type, ga, cmp)           genalloc_qsort_full(type, (ga), 0, genalloc_len(type, (ga)), cmp)
#define genalloc_qsort_r(type, ga, cmp, ctx)    genalloc_qsort_r_full(type, (ga), 0, genalloc_len(type, (ga)), cmp, ctx)

#endif /* LIMB_GENALLOC_H */
