/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_HEX_H
#define LIMB_HEX_H

#include <sys/types.h>

enum {
    HEX_SP        = 1 << 0,
    HEX_LF        = 1 << 1,
    HEX_1BLOCK_LF = 1 << 3,
    HEX_2BLOCK_LF = 1 << 4,
    HEX_3BLOCK_LF = HEX_1BLOCK_LF | HEX_2BLOCK_LF,
    HEX_4BLOCK_LF = 1 << 5,
    HEX_BLOCKS_LF = HEX_3BLOCK_LF | HEX_4BLOCK_LF,
    HEX_1BLOCK_SP = 1 << 6,
    HEX_2BLOCK_SP = 1 << 7,
    HEX_3BLOCK_SP = HEX_1BLOCK_SP | HEX_2BLOCK_SP,
    HEX_4BLOCK_SP = 1 << 8,
    HEX_BLOCKS_SP = HEX_3BLOCK_SP | HEX_4BLOCK_SP,
    HEX_BLOCKS    = HEX_BLOCKS_LF | HEX_BLOCKS_SP,
};

extern int hexall_fmt(char *dst, size_t dlen, const char *sce, size_t slen, int options, size_t *w, size_t *r);
extern ssize_t hex_fmt(char *dst, size_t dlen, const char *sce, size_t slen, int options);

#endif /* LIMB_HEX_H */
