/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_HMAP_H
#define LIMB_HMAP_H

#include <limb/int.h>
#include <limb/stralloc.h>

typedef struct hmap hmap;

struct hmap {
    stralloc sa;
    size_t ilen;
};

#define HMAP_ZERO       { STRALLOC_ZERO, 0 }

extern int hmap_init(size_t dlen, size_t n, hmap *hmap);
extern int hmap_set(u32 key, void *data, hmap *hmap);
extern void *hmap_next(u32 *key, hmap *hmap);
extern void *hmap_get(u32 key, hmap *hmap);
extern void hmap_free(hmap *hmap);

#endif /* LIMB_HMAP_H */
