/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_MEMXOR_H
#define LIMB_MEMXOR_H

#include <stddef.h> /* size_t */
#include <limb/int.h>

/* The word_t type is intended to be the native word size. */
#if defined(__x86_64__) || defined(__arch64__)
typedef u64 word_t;
#else
typedef unsigned long int word_t;
#endif

#define ALIGN_OFFSET(p) ((uintptr_t) (p) % sizeof(word_t))

extern void memxor(void *dst, const void *src, size_t len);
extern void memxor3(void *dst, const void *src1, const void *src2, size_t len);

#endif /* LIMB_MEMXOR_H */
