/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_PATRIM_H
#define LIMB_PATRIM_H

#include <sys/types.h>
#include <limb/int.h>

#define patrim_isblob(id)       (id & 1)
#define patrim_isint(id)        !patrim_isblob(id)
#define patrim_isshldata(id)    (id & (1 << 6))

extern int patrim_put(char *dst, size_t dlen, size_t offset, u64 id, u64 u);
extern int patrim_get(u64 *id, u64 *u, const char *data, size_t dlen, size_t offset);

#endif /* LIMB_PATRIM_H */
