/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_POLY1305_H
#define LIMB_POLY1305_H

#include <stddef.h> /* size_t */
#include <limb/int.h>

#define POLY1305_BLOCKSIZE      16

struct poly1305_ctx {
    u32 r[5];
    u32 s[5];
    u32 a[5];
    size_t leftover;
    u8 buf[POLY1305_BLOCKSIZE];
    u8 final;
};

typedef struct poly1305_ctx poly1305_ctx;

extern void poly1305_init(const void *key, void *ctx);
extern void poly1305_update(const void *msg, size_t mlen, void *ctx);
extern void poly1305_final(void *dst, void *ctx);

#endif /* LIMB_POLY1305_H */
