/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_SHLDATA_RW_H
#define LIMB_SHLDATA_RW_H

#include <limb/int.h>
#include <limb/siovec.h>
#include <limb/stralloc.h>

#define SHLDATA_MASK        0xf0f0f800
#define SHLDATA_MAGIC       0xa0e0f800

extern int shldata_chkmagic(u32 magic);

extern int shldata_write(int bfd, const char *file, u32 magic, u64 ver,
                         const char *pwd, size_t plen, unsigned algo, unsigned iter,
                         int inplace, const struct iovec v[], unsigned n);
extern int shldata_read(u32 *magic, u64 *ver, unsigned *algo, unsigned *iter, stralloc *sa,
                        int bfd, const char *file, const char *pwd, size_t plen);

#endif /* LIMB_SHLDATA_RW_H */
