/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_SHLDATA_H
#define LIMB_SHLDATA_H

#include <sys/types.h>
#include <limb/ccpl.h>

struct shldata_ctx {
    ccpl_ctx ccpl;
    size_t len;
    size_t done;
};

typedef struct shldata_ctx shldata_ctx;

extern ssize_t shldata_initw(char *dst, size_t dlen, const char *pwd, size_t plen,
                             unsigned algo, unsigned iter, size_t len, shldata_ctx *ctx);
extern int shldata_encrypt(char *dst, const char *data, size_t dlen, shldata_ctx *ctx);
extern ssize_t shldata_predata(char *dst, size_t dlen, shldata_ctx *ctx);
extern ssize_t shldata_finalw(char *dst, size_t dlen, shldata_ctx *ctx);


extern ssize_t shldata_initr(const char *sce, size_t slen, const char *pwd, size_t plen, unsigned *algo, unsigned *iter, shldata_ctx *ctx);
#define shldata_datasize(ctx)       (ctx)->len
extern int shldata_decrypt(char *dst, const char *sce, size_t len, shldata_ctx *ctx);
extern ssize_t shldata_finalr(const char *sce, size_t slen, shldata_ctx *ctx);

#endif /* LIMB_SHLDATA_H */
