/* This file is part of limb                           https://lila.oss/limb
 * Copyright (C) 2023 Olivier Brunel                          jjk@jjacky.com */
/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef LIMB_SIOVEC_H
#define LIMB_SIOVEC_H

#include <skalibs/siovec.h>

#define siov_len(v,n)                       siovec_len(v, n)
#define siov_gather(dst,max,v,n)            siovec_gather(v, n, dst, max)
#define siov_scatter(v,n,sce,len)           siovec_scatter(v, n, sce, len)
#define siov_deal(vdst,ndst,vsce,nsce)      siovec_deal(vdst, ndst, vsce, nsce)
#define siov_seek(v,n,o)                    siovec_seek(v, n, o)
#define siov_trunc(v,n,l)                   siovec_trunc(v, n, l)

#define siov_bytechr(v,n,c)                 siovec_bytechr(v, n, c)
#define siov_bytein(v,n,s,l)                siovec_bytein(v, n, s, l)
#define siov_search(v,n,s,l)                siovec_search(v, n, s, l)

extern size_t siov_gather0(char *dst, size_t max, const struct iovec *v, unsigned int n);
extern int siov_memcmp(const struct iovec *v, unsigned int n, const char *s, size_t len);
extern int siov_off(const struct iovec *v, unsigned int n, size_t off);

extern size_t siov_seek_gather(char *dst, size_t max, const struct iovec *v, unsigned int n, size_t offset);
extern size_t siov_seek_gather0(char *dst, size_t max, const struct iovec *v, unsigned int n, size_t offset);
extern size_t siov_seek_bytechr(const struct iovec *v, unsigned int n, size_t offset, char c);
extern size_t siov_seek_bytein(const struct iovec *v, unsigned int n, size_t offset, const char *sep, size_t len);

#endif /* LIMB_SIOVEC_H */
